'use strict';

angular.module('adf.widget.electre.symod', ['adf.provider'])
    .constant('SYMOD_TEMPLATE_PATH', "/widgets/symod/templates")
    .value("fusionChartTypes", {
        defaultType : 'mscolumn2d',
        types : [
            "mscolumn2d",
            "mscolumn3d",
            "msline",
            "msbar2d",
            "msbar3d",
            "msarea",
            "marimekko",
            "zoomline",
            "zoomlinedy"
        ]
    })
    .config(
        [
            "dashboardProvider",
            function (dashboardProvider) {
                dashboardProvider.widget('symodChart', {
                    title        : 'Fusion chart Widget',
                    display      : 'Fusion chart widget for dashboard electre',
                    description  : 'Display a chart using fusion chart from json data.',
                    controller   : 'symodChartCtrl',
                    controllerAs : 'symodChart',
                    templateUrl  : "{widgetsPath}/symod/templates/view.html",
                    reload       : true,
                    resolve : {
                        isEdit: function () {return false;}
                    },
                    edit         : {
                        controller  : "symodChartCtrl",
                        immediate   : true,
                        templateUrl : "{widgetsPath}/symod/templates/edit.html",
                        resolve : {
                            isEdit : function () { return true;}
                        }
                    }
                });
            }
        ]
    )
    .controller("symodChartCtrl", [
        "$scope", "config", "isEdit", "fusionChartTypes", "domService",
        function ($scope, config, isEdit, fusionChartTypes, domService) {
            $scope.more_settings = $scope.more_settings || false;
            if (isEdit) {
                config.type   = config.type   || fusionChartTypes.defaultType;
                config.width  = config.width  || 100; config.widthPercentage = config.widthPercentage || true;
                config.height = config.height || 300; config.heightPercentage= config.heightPercentage|| false;

                var type = document.getElementById("type");
                for (var t = 0 ; t < fusionChartTypes.types.length ; t++) {
                    var option = domService.createElement("option").setAttribute('value', fusionChartTypes.types[t]).getDom();
                    option.innerHTML = option.getAttribute('value');
                    type.appendChild(option);
                }
            } else {
                $scope.polymerFusionChartConfig = {
                    width : config.width + (config.widthPercentage ? "%" : ""),
                    height: config.height+ (config.heightPercentage? "%" : ""),
                    type  : config.type,
                    url   : config.url
                };

                if ($scope.polymerFusionChartConfig.url) $scope.valid = true;
            }
        }
    ]);